/*
          -=  =-
         
 = License
 ~~~~~~~~~
 Copyright (c) 2005 Remo Dentato licensed under the terms of the MIT license:
 http://www.opensource.org/licenses/mit-license.php
 
 Short version:
 
  Do whatever you want with this software but give me credit as
  the original author and don't blame me if anything goes wrong!
 
  rdentato@users.sourceforge.net
*/
/*
The '|-- EXCLUDE| directive tells which section to skip. You can specify more than one
using colons: '|:INFO:PRINT:|

It's a good idea to use only capital letters to name the sections.

If the section '|XXX| will be included, a symbol '|ABC_STR_XXX| will be defined.

-- EXCLUDE :NONE:

Note that this section will be always included!

-- BEGIN
       1F01 begintext textbegin
       1F02 endtext textend
       1882 propagate-accidentals
       1E07 abc-include include
       1E01 text center centertext righttext lefttext

       524E %none 
       5250 %perc %percussion %drum 
       
       5041 %french %frenchviolin
       5042 %violin 
       5051 %soprano 
       5052 %mezzo %mezzosoprano
       5054 %tenor 
       5055 %baritone 
       5065 %subbass 
       
       504A %treble 
       505A %alto 
       506A %bass 
       
       507A %doh 
       508A %fa 
       
       5130 %tablature   %tab
       5132 %frenchtab 
       5133 %french4tab 
       5134 %french5tab 
       5135 %spanishtab  %guitartab
       5136 %spanish4tab 
       5137 %spanish5tab 
       5138 %banjo4tab 
       5139 %banjo5tab 
       513A %ukuleletab 
       
       513B %italiantab 
       513C %italian4tab 
       513D %italian5tab 
       513E %italian7tab 
       513F %italian8tab 
       
       5155 %strings
        
       5E21 %staves       %stv
       5E22 %bracket      %brk 
       5E23 %brace        %brc
       5E24 %merge
       5E2A %space        %spc
       5E2B %octave       %o
       5E2C %transpose    %t
       5E2D %stafflines   %s
       5E2E %middle       %m
       5E2F %gstem
       5E30 %stem
       5E31 %name         %nm
       5E32 %subname      %snm %shortname
       5E33 %clef
       5E34 %instrument   %instr %i
       5E35 %dyn
       5E36 %lyrics

       5EF0 %head
       
       300D &chordname    chordname
       
       
-- END   
         
-- BEGIN INFO     
       1E03 abc-copyright
       1E04 abc-version  
       1E05 abc-creator  
       1E06 abc-charset  abc-encoding
       1E08 abc-edited-by
-- END INFO

-- BEGIN PRINT
    -none
       1F03 newpage
       1F04 vskip
       
    -<ABCString>
  
    -<fontname> <size>
       1D01 annotationfont
       1D02 composerfont
       1D03 gchordfont
       1D04 infofont
       1D06 partsfont
       1D07 subtitlefont
       1D08 setfont-1
       1D09 setfont-2
       1D0A setfont-3
       1D0B setfont-4
       1D0C tempofont
       1D0D textfont
       1D0E titlefont
       1D0F vocalfont
       1D10 wordsfont
       
    -<length>
       1C01 botmargin
       1C02 composerspace
       1C03 indent
       1C04 infospace
       1C06 leftmargin
       1C07 musicspace
       1C08 pageheight
       1C09 pagewidth
       1C0A partsspace
       1C0B rightmargin
       1C0C staffsep
       1C0D subtitlespace
       1C0E sysstaffsep
       1C0F textspace
       1C10 titlespace
       1C11 topmargin
       1C12 topspace
       1C13 vocalspace
       1C14 wordsspace
    
    -<logical>
       1B01 continueall
       1B02 exprabove
       1B03 exprbelow
       1B04 freegchord
       1B05 musiconly
       1B06 measurebox
       1B07 graceslurs
       1B08 infoline
       1B09 landscape
       1B0A oneperpage
       1B0B printtempo
       1B0C stretchlast
       1B0D stretchstaff
       1B0E vocalabove
       1B0F withxrefs
       1B10 writehistory
         
    -<number>
       1A01 lineskipfac
       1A02 maxshrink
       1A03 parskipfac
       1A04 sep
       1A05 scale
         
    -<integer>
       1901 barnumbers
       1902 barsperstaff
       1903 measurefirst
       1904 measurenb
       1905 setbarnb
          
    -<mix>
       
            - A<num>|<lenght>x<length>
       1881 papersize 
       
            - <voice-id1> <voice-id2>...<voice-idn>
       1883 score staves
       
            - none|added|all
       1884 writeout-accidentals
       
       1885 deco
       
       1886 postscript
       
    - heads   
       2EF1 %head-plus      %plus     
       2EF2 %head-x         %x        
       2EF3 %head-xcircle   %xcircle  
       2EF4 %head-square    %square   
       2EF5 %head-wsquare   %wsquare  
       2EF6 %head-triangle  %triangle 
       2EF7 %head-wtriangle %wtriangle
       2EF8 %head-diamond   %diamond  
       2EF9 %head-wdiamond  %wdiamond 

-- END PRINT

-- BEGIN DECORATIONS  
    - 1 dynamics signs
       2101 pppp pianissississimo
       2102 ppp  pianississimo
       2103 pp   pianissimo
       2104 p    piano
       2105 mp   mezzopiano
       2106 mf   mezzoforte
       2107 f    forte
       2108 ff   fortissimo
       2109 fff  fortississimo
       210A ffff fortissississimo
       210B fp   fortepiano
       210C sfz  fz sforzando
       210D rfz  rf rinforzando
       210E sfp  sforzandopiano 
       210F niente n
       2110 sffff  subitoffff subitofortissississimo
       2111 sfff   subitofff  subitofortississimo
       2112 sff    subitoff   subitofortissimo
       2113 sf     subitof    subitoforte
       2114 smf    subitomf   subitomezzoforte
       2115 smp    subitomp   subitomezzopiano
       2116 sp     subitop    subitopiano
       2117 spp    subitopp   subitopianissimo
       2118 sppp   subitoppp  subitopianississimo
       2119 spppp  subitopppp subitopianissississimo
       211C crescendo 
       211D <(
       211E <)
       2120 diminuendo
       2121 >(
       2122 >)
       2125 glissando   g     
        
     -2 Fingering
       2201 1
       2202 2
       2203 3
       2204 4
       2205 5
       2206 arpeggio
       2207 arpeggioup
       2208 arpeggiodown
       2209 arrow
       220A arrowup
       220B arrowdown
       220C noarpeggio 
       220D H.O. hammeringon
       220E P.O. pulloff
       220F SL.  sliding
       2210 W.   wham
       2211 strum
       2212 strumup
       2213 strumdown
       2214 m.g. mg. lefthand
       2215 m.d. md. righthand
       2216 pizzicato
       2217 bartokpizzicato snappizzicato
        
     -A Articulation
       2A01 accent  emphasis >
       2A02 marcato
       2A03 staccatissimo
       2A04 staccato 
       2A05 tenuto
       2A06 portato
       2A07 upbow
       2A08 downbow
       2A09 flageolet
       2A0A thumb
       2A0B lheel
       2A0C rheel
       2A0D ltoe
       2A0E rtoe
       2A0F open
       2A10 stopped
       2A12 reverseturn  invertedturn
       2A13 trill  tr
       2A14 prall
       2A15 mordent lowermordent
       2A16 prallprall
       2A17 prallmordent
       2A18 upprall
       2A19 downprall
       2A1A upmordent    uppermordent pralltriller
       2A1B downmordent  
       2A1C pralldown
       2A1D prallup
       2A1E lineprall
       2A1F signumcongruentiae
       2A20 slide
       2A22 reverseturnx   invertedturnx
       2A25 roll irishroll ~
       2A30 turn
       2A31 turnb
       2A32 bturn
       2A33 turn#
       2A34 #turn
       2A35 turnx
       2A36 xturn
       2A37 turnbb
       2A38 bbturn
       2A39 turn##
       2A3A ##turn
            
        
    - 3 percussions
       2301 Gong
       2302 Triangle
       2303 HalfOpenHiHat
       2304 HardStick
       2305 SoftStick
       2306 MetalStick
       2307 RubberStick
       2308 TriangleStick
       2309 WireBrush
       230A WoodStick
       2326 Snare
       232A HiHat
       
    - 4 pedal
        
       2401 damppedal ped 
       2402 sostpedal mped
       2404 softpedal lped
       
    - 5 pause
       2501 breath
       2502 fermata hold H
       2503 shortfermata
       2504 longfermata
       2505 verylongfermata
       2506 generalpause G.P.
       2507 caesura pause rr //
       2508 reversefermata invertedfermata ufermata udfermata
       2509 grandpause
                        
    - 6 misc
       2601 segno
       2602 coda
       2603 D.S.
       2604 D.C. 
       2605 dacoda
       2606 dacapo
       2607 dalsegno
       2608 fine
       2609 varcoda
       260A shortphrase
       260B mediumphrase
       260C longphrase
       260D 8va
       260F 8vab
       2611 beamon
       2612 gmark
       2613 invisible
       2640 stemup
       2641 stemdown
		   2642 beambr1
		   2643 beambr2
		   2644 trem1
		   2645 trem4
		   2646 xstem
-- END DECORATIONS  
  



-- BEGIN TAB  
       0701 tabfontsize
       0702 tabfontscale
       0703 tabfontfrench
       0704 tabfontitalian
       0705 tabaddflags
       0706 tabflagspace
       0707 tabrhstyle
       0708 taballflags
       0709 tabledgeabove
-- END TAB

-- BEGIN MIDI     
       3001 midi
       3002 &channel
       3003 &program
       3004 &beat
       3005 &beatmod
       3006 &deltaloudness
       3007 &beatstring
       3008 &transpose
       3009 &rtranspose
       300A &c
       300B &grace
       300C &gracedivider
       300F &gchord
       3011 &chordprog
       3012 &bassprog
       3013 &chordvol
       3014 &bassvol
       3015 &gchordon
       3016 &gchordoff
       3017 &fermatafixed
       3018 &fermataproportional
       3019 &droneon
       301A &droneoff
       301B &drone
       301C &drum
       301D &drumon
       301F &drumoff
       3021 &control
       3023 &portamento
       3024 &noportamento
       3025 &pitchbend
       3026 &nobarlines
       3027 &barlines
       3028 &ratio
       3029 &chordattack
       302A &randomchordattack
       
       3101 &setpercussion setpercussion
-- END MIDI

-- BEGIN INSTRUMENT
       0800 AcousticGrandPiano   AcousticGrand
       0801 BrightAcousticPiano  BrightAcoustic AcousticBright
       0802 ElectricGrandPiano   ElectricGrand
       0803 HonkyTonkPiano       HonkyTonk
       0804 RhodesPiano          Rhodes
       0805 ChorusedPiano        Chorused
       0806 Harpsichord       
       0807 Clavinet          
       0808 Celesta           
       0809 Glockenspiel      
       080A MusicBox          
       080B Vibraphone        
       080C Marimba           
       080D Xylophone         
       080E TubularBells      
       080F Dulcimer          
       0810 HammondOrgan         Hammond
       0811 PercussiveOrgan
       0812 RockOrgan         
       0813 ChurchOrgan       
       0814 ReedOrgan         
       0815 Accordion         
       0816 Harmonica         
       0817 TangoAccordion    
       0818 AcousticGuitarNylon  Guitar
       0819 AcousticGuitarSteel
       081A ElectricGuitarJazz
       081B ElectricGuitarClean  ElectricGuitar
       081C ElectricGuitarMuted
       081D OverdrivenGuitar  
       081E DistortionGuitar  
       081F GuitarHarmonics   
       0820 AcousticBass         Bass
       0821 ElectricBassFinger
       0822 ElectricBassPick  
       0823 FretlessBass      
       0824 SlapBass1         
       0825 SlapBass2         
       0826 SynthBass1        
       0827 SynthBass2        
       0828 Violin            
       0829 Viola             
       082A Cello             
       082B Contrabass        
       082C TremoloStrings    
       082D PizzicatoStrings  
       082E OrchestralHarp    
       082F Timpani           
       0830 StringEnsemble1   
       0831 StringEnsemble2   
       0832 SynthStrings1     
       0833 SynthStrings2     
       0834 ChoirAahs         
       0835 VoiceOohs         
       0836 SynthVoice        
       0837 OrchestraHit      
       0838 Trumpet           
       0839 Trombone          
       083A Tuba              
       083B MutedTrumpet      
       083C FrenchHorn        
       083D BrassSection      
       083E SynthBrass1       
       083F SynthBrass2       
       0840 SopranoSax        
       0841 AltoSax           
       0842 TenorSax          
       0843 BaritoneSax       
       0844 Oboe              
       0845 EnglishHorn       
       0846 Bassoon           
       0847 Clarinet          
       0848 Piccolo           
       0849 Flute             
       084A Recorder          
       084B PanFlute          
       084C BottleBlow        
       084D Shakuhachi        
       084E Whistle           
       084F Ocarina           
       0850 Lead1 LeadSquare  
       0851 Lead2 LeadSawtooth
       0852 Lead3 LeadCaliope
       0853 Lead4 LeadChiff
       0854 Lead5 LeadCharang 
       0855 Lead6 LeadVoice   
       0856 Lead7 LeadFifths  
       0857 Lead8 LeadBrass
       0858 Pad1 PadNewage    
       0859 Pad2 PadWarm      
       085A Pad3 PadPolysynth 
       085B Pad4 PadChoir     
       085C Pad5 PadBowed     
       085D Pad6 PadMetallic  
       085E Pad7 PadHalo      
       085F Pad8 PadSweep     
       0860 FX1 FXRain        
       0861 FX2 FXSoundtrack  
       0862 FX3 FXCrystal     
       0863 FX4 FXAtmosphere  
       0864 FX5 FXBrightness  
       0865 FX6 FXGoblins     
       0866 FX7 FXEchoes      
       0867 FX8 FXSciFi      
       0868 Sitar             
       0869 Banjo             
       086A Shamisen          
       086B Koto              
       086C Kalimba           
       086D Bagpipe           
       086E Fiddle            
       086F Shanai            
       0870 TinkleBell        
       0871 Agogo             
       0872 SteelDrums        
       0873 Woodblock         
       0874 TaikoDrum         
       0875 MelodicTom        
       0876 SynthDrum         
       0877 ReverseCymbal     
       0878 GuitarFretNoise   
       0879 BreathNoise       
       087A Seashore          
       087B BirdTweet         
       087C TelephoneRing     
       087D Helicopter        
       087E Applause          
       087F Gunshot           
       2823 AcousticBassDrum
       2824 BassDrum1
       2825 SideStick
       2826 AcousticSnare
       2827 HandClap
       2828 ElectricSnare
       2829 LowFloorTom
       282A ClosedHiHat
       282B HighFloorTom
       282C PedalHiHat
       282D LowTom
       282E OpenHiHat
       282F LowMidTom
       2830 HiMidTom
       2831 CrashCymbal1
       2832 HighTom
       2833 RideCymbal1
       2834 ChineseCymbal
       2835 RideBell
       2836 Tambourine
       2837 SplashCymbal
       2838 Cowbell
       2839 CrashCymbal2
       283A Vibraslap
       283B RideCymbal2
       283C HiBongo
       283D LowBongo
       283E MuteHiConga
       283F OpenHiConga
       2840 LowConga
       2841 HighTimbale
       2842 LowTimbale
       2843 HighAgogo
       2844 LowAgogo
       2845 Cabasa
       2846 Maracas
       2847 ShortWhistle
       2848 LongWhistle
       2849 ShortGuiro
       284A LongGuiro
       284B Claves
       284C HiWoodBlock
       284D LowWoodBlock
       284E MuteCuica
       284F OpenCuica
       2850 MuteTriangle
       2851 OpenTriangle
-- END INSTRUMENT

-- BEGIN TEMPO
       0B01 Adagio
       0B02 Allegro
       0B03 Andante
       0B04 Grave
       0B05 Largo
       0B06 Lento
       0B07 Presto
       0B08 Adagietto
       0B09 Allegretto
       0B0A Andantino
       0B0B Larghetto
       0B0C Mosso
       0B0D Prestissimo
       0B0E Agitato
       0B0F Amabile
       0B10 Animato
       0B11 Appassionato
       0B12 Cantabile
       0B13 Comodo
       0B14 ConAnima
       0B15 ConBrio
       0B16 ConFuoco
       0B17 ConMoto
       0B18 ConSpirito
       0B19 Giusto
       0B1A Grazioso
       0B1B Risoluto
       0B1C Sostenuto
       0B1D Tranquillo
       0B1E Vivace
       0B1F Vivo
       0B20 Mesto
       0B21 Maestoso
       0B22 Moderato
-- END TEMPO
 

*/

typedef struct {
  unsigned short  code;
  unsigned short  offs;
} abc_str;

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define STRICMP strcasecmp

#ifdef ABC_DLL
#include <windows.h>
#define ABCAPI __declspec(dllexport)
#else
#define ABCAPI
#endif

#include "dbg.h"

#define  ABC_STRINGS_C
#include "abcp_strings.h"

static short bsrch(void *key,void *arr,unsigned short num, int comp(void *,void *, short))
{
    short i,j,k,n;
    
    i=0; j=num;
    
    while (i<=j) {
      k=(i+j)/2;
      n=comp(key,arr,k);
      if (n<0) j=k-1;
      else if (n>0) i=k+1;
      else break;
    }
    if (i<=j) return k;
   return -1;
}

static int cmpstr(unsigned char *a, abc_str *arr, unsigned short k)
{   dbg_printf((0,"<%s><%s>\n",a, strbuf+arr[k].offs));
	return (STRICMP(a,strbuf+arr[k].offs)); }

unsigned short ABCAPI abc_ChkString(char *str)
{
  if (str && *str) {
    short in = bsrch(str,strs,ABC_NUMSTRS,(void *)cmpstr);
    if (in >= 0) return strs[in].code;
  }
  return 0;
}

static int cmplstr(unsigned char *a, abc_str *arr, unsigned short k)
{ 
  static unsigned short slen=0;
  char *s;
  int l=0;
  int t=0;

  
  if (a == NULL) {
	slen = k;
	return k;
  }  
  s=strbuf+arr[k].offs;
  dbg_printf((0,"<%s><%s>\n",a, s));
  while (*s && l<slen && t==0) {
	t=tolower((*a++)) - tolower((*s++));
	l++;
  }
  
  if (t != 0) return t;
  if (l < slen) return 1;
  if (*s != '\0') return -1;
  return 0; 

}

unsigned short ABCAPI abc_ChkNString(char *str,int len)
{
  short in;
  if (str && *str) {
    cmplstr(NULL,NULL,len);  /* set string length */
    in = bsrch(str,strs,ABC_NUMSTRS,(void *)cmplstr);
    if (in >= 0) {
	    return strs[in].code;
    }
  }
  return 0; 
}


static int cmprev(unsigned short *a, unsigned short *arr, unsigned short k)
{   dbg_printf((0,"<%04X><%04X>\n",*a, strs[arr[k]].code));
	return (*a - strs[arr[k]].code); }

char * ABCAPI abc_RevString(unsigned short code)
{
  char *t = NULL;
  unsigned short x=code;
  short in = bsrch(&x,rev,ABC_NUMREV,(void *)cmprev);
  if (in >= 0) {
	  t = strbuf+strs[rev[in]].offs;
	  if (*t < '/') t++;
  }
  return t;	
}

