#ifndef _RE_H_
#define _RE_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
 
  char *re_comp  (unsigned char *pat, unsigned char *nfa);
  int   re_exec  (unsigned char *lp,  unsigned char *nfa);
  char *re_end   (unsigned char n);
  char *re_start (unsigned char n);
  int   re_len   (unsigned char n);
  char *re_cpy   (unsigned char *dst,unsigned char n);
  char *re_ncpy  (unsigned char *dst,unsigned char n,int l);
  int   re_dump  (FILE *f,unsigned char *s,unsigned char h);

  
#define RE_MAXNFA  1024

#endif /* _RE_H_*/
